#include "testconfig.h"
#ifdef HAVE_FDIM
#define TEST_FUNC_FF_F __MATH_PRECNAME(fdim)
#include "testdriver.h"


static test_ff_f_data const fdim_data[] = {
	{ __LINE__, ZERO_P, ZERO_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), ZERO_P, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), NO_INEXACT_EXCEPTION },
	{ __LINE__, ZERO_P, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), ZERO_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, ZERO_P, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), NO_INEXACT_EXCEPTION },

	{ __LINE__, ZERO_P, ZERO_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, ZERO_M, ZERO_M, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, ZERO_P, ZERO_M, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, ZERO_M, ZERO_P, ZERO_P, NO_INEXACT_EXCEPTION },

	{ __LINE__, INF_P, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), INF_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_P, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), INF_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_M, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_M, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), INF_M, INF_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), INF_M, INF_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), INF_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), INF_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_P, INF_P, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_M, INF_M, ZERO_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_P, INF_M, INF_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_M, INF_P, ZERO_P, NO_INEXACT_EXCEPTION },

	/* If x or y is a NaN, a NaN is returned. */
	{ __LINE__, ZERO_P, QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, QNAN_P, HEXCONSTE(9, 0x4002, 0x90000000L, 0x00000000L), QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, QNAN_P, HEXCONSTE(-9, 0xc002, 0x90000000L, 0x00000000L), QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_P, QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, INF_M, QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, QNAN_P, INF_P, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, QNAN_P, INF_M, QNAN_P, NO_INEXACT_EXCEPTION },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, NO_INEXACT_EXCEPTION },

	{ __LINE__, INF_P, INF_P, ZERO_P, NO_INEXACT_EXCEPTION },
};

int main(int argc, char **argv)
{
	int status;
	
	status = 0;
	
	test_init(argc, argv);
	
	status |= test_table_ff_f(fdim_data, ARRAY_SIZE(fdim_data), __FILE__);
	
	return status ? EXIT_FAILURE : EXIT_SUCCESS;
}

#else

int main(void)
{
	return 77;
}

#endif
