#include "testconfig.h"
#define TEST_FUNC_FF_F __MATH_PRECNAME(wrap_mul)
static REAL TEST_FUNC_FF_F(REAL x, REAL y)
{
	return x * y;
}
#include "testdriver.h"



static test_ff_f_data const fmul_data[] = {
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_P, ZERO_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_P, ZERO_P, FLAG_IGNORE_ZEROSIGN },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_P, ZERO_P, FLAG_IGNORE_ZEROSIGN },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_M, ZERO_P, FLAG_IGNORE_ZEROSIGN },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), ZERO_P, 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_M, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_M, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), ZERO_P, 0 },
	{ __LINE__, ZERO_P, ZERO_P, ZERO_P, 0 },
	{ __LINE__, ZERO_P, ZERO_M, ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_M, ZERO_P, ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_M, ZERO_M, ZERO_P, 0 },
	{ __LINE__, ZERO_P, INF_P, QNAN_P, 0 },
	{ __LINE__, ZERO_P, INF_M, QNAN_P, 0 },
	{ __LINE__, ZERO_M, INF_P, QNAN_P, 0 },
	{ __LINE__, ZERO_M, INF_M, QNAN_P, 0 },
	{ __LINE__, INF_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_P, ZERO_P, QNAN_P, 0 },
	{ __LINE__, INF_P, ZERO_M, QNAN_P, 0 },
	{ __LINE__, INF_M, ZERO_P, QNAN_P, 0 },
	{ __LINE__, INF_M, ZERO_M, QNAN_P, 0 },
	{ __LINE__, INF_P, INF_P, INF_P, 0 },
	{ __LINE__, INF_P, INF_M, INF_M, 0 },
	{ __LINE__, INF_M, INF_P, INF_M, 0 },
	{ __LINE__, INF_M, INF_M, INF_P, 0 },

	{ __LINE__, ZERO_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, INF_P, QNAN_P, FLAG_FAIL_SOFTFLOAT }, /* returns Inf instead of NaN */
	{ __LINE__, QNAN_M, INF_P, QNAN_M, FLAG_FAIL_SOFTFLOAT }, /* returns Inf instead of NaN */
	{ __LINE__, QNAN_P, INF_M, QNAN_M, FLAG_FAIL_SOFTFLOAT }, /* returns Inf instead of NaN */
	{ __LINE__, QNAN_M, INF_M, QNAN_P, FLAG_FAIL_SOFTFLOAT }, /* returns Inf instead of NaN */
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },

	{ __LINE__, HEXCONST_PI, HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), HEXCONSTE(9.42477796076937971576e+00, 0x4002, 0x96cbe3f9L, 0x990e91a8L), 0 },
	{ __LINE__, HEXCONSTE(-1, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(1023, 0x4008, 0xffc00000L, 0x00000000L), HEXCONSTE(-1023, 0xc008, 0xffc00000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE("0x1p16382", 0x7ffd, 0x80000000L, 0x0L), HEXCONSTE("0x1p16383", 0x7ffe, 0x80000000L, 0x0L), 0 },
	{ __LINE__, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE("0x1p16383", 0x7ffe, 0x80000000L, 0x0L), INF_P, 0 },
};

int main(int argc, char **argv)
{
	int status;
	
 	status = 0;
	
	test_init(argc, argv);
	
	status |= test_table_ff_f(fmul_data, ARRAY_SIZE(fmul_data), __FILE__);
	
	return status ? EXIT_FAILURE : EXIT_SUCCESS;
}
