#include "testconfig.h"
#define TEST_FUNC_FF_F __MATH_PRECNAME(wrap_sub)
/* FIXME: sometimes totally bogus values in ARAnyM when inlined */
__attribute__((__noinline__))
static REAL TEST_FUNC_FF_F(REAL x, REAL y)
{
	return x - y;
}
#include "testdriver.h"



static test_ff_f_data const fsub_data[] = {
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L),  HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(-3.0, 0xc000, 0xc0000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L),  HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_M, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_M, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_P, ZERO_P, ZERO_P, 0 },
	{ __LINE__, ZERO_P, ZERO_M, ZERO_P, 0 },
	{ __LINE__, ZERO_M, ZERO_P, ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_M, ZERO_M, ZERO_P, 0 },
	{ __LINE__, ZERO_P, INF_P, INF_P, 0 },
	{ __LINE__, ZERO_P, INF_M, INF_M, 0 },
	{ __LINE__, ZERO_M, INF_P, INF_P, 0 },
	{ __LINE__, ZERO_M, INF_M, INF_M, 0 },
	{ __LINE__, INF_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_P, ZERO_P, INF_P, 0 },
	{ __LINE__, INF_P, ZERO_M, INF_P, 0 },
	{ __LINE__, INF_M, ZERO_P, INF_M, 0 },
	{ __LINE__, INF_M, ZERO_M, INF_M, 0 },
	{ __LINE__, INF_P, INF_P, QNAN_P, 0 },
	{ __LINE__, INF_P, INF_M, INF_P, 0 }, /* documentation says -inf, but is wrong */
	{ __LINE__, INF_M, INF_P, INF_M, 0 },
	{ __LINE__, INF_M, INF_M, QNAN_P, 0 },

	{ __LINE__, ZERO_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, INF_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, INF_P, QNAN_M, 0 },
	{ __LINE__, QNAN_P, INF_M, QNAN_M, 0 },
	{ __LINE__, QNAN_M, INF_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },

#ifdef TEST_LDOUBLE
	{ __LINE__, HEXCONST_PI, HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), HEXCONSTE(0.141592653589793238462643383279502884, 0x3ffc, 0x90fdaa22L, 0x168c2350L), 0 },
#endif
#ifdef TEST_DOUBLE
	{ __LINE__, HEXCONST_PI, HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), HEXCONSTE(1.4159265358979311599796e-01, 0x3ffc, 0x90fdaa22L, 0x168c0000L), 0 },
#endif
};


int main(int argc, char **argv)
{
	int status;
	
	status = 0;
	
	test_init(argc, argv);
	
	status |= test_table_ff_f(fsub_data, ARRAY_SIZE(fsub_data), __FILE__);
	
	return status ? EXIT_FAILURE : EXIT_SUCCESS;
}
